// t2sDlg.cpp : implementation file
// Copyright(C) Sollae Systems Co.,Ltd.
// 06.Nov.2000 yyc  initial touch
//

#include "stdafx.h"
#include "ezsock.h"
#include "u2s.h"
#include "u2sDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CU2sDlg dialog

CU2sDlg::CU2sDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CU2sDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CU2sDlg)
	m_remote_udp_port = 0;
	m_local_udp_port = 0;
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CU2sDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CU2sDlg)
	DDX_Control(pDX, IDC_CHECK_LF, m_check_lf);
	DDX_Control(pDX, IDC_CHECK_CR, m_check_cr);
	DDX_Control(pDX, IDC_SEND, m_send);
	DDX_Control(pDX, IDC_EDIT_SEND, m_send_box);
	DDX_Control(pDX, IDC_CONSOLE, m_console);
	DDX_Control(pDX, IDC_REMOTE_IP, m_remote_ip);
	DDX_Control(pDX, IDC_BIND_CLOSE, m_bind_close);
	DDX_Control(pDX, IDC_BIND, m_bind);
	DDX_Text(pDX, IDC_REMOTE_UDP_PORT, m_remote_udp_port);
	DDV_MinMaxUInt(pDX, m_remote_udp_port, 0, 65535);
	DDX_Text(pDX, IDC_LOCAL_UDP_PORT, m_local_udp_port);
	DDV_MinMaxUInt(pDX, m_local_udp_port, 0, 65535);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CU2sDlg, CDialog)
	//{{AFX_MSG_MAP(CU2sDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BIND, OnBind)
	ON_BN_CLICKED(IDC_BIND_CLOSE, OnBindClose)
	ON_BN_CLICKED(IDC_EXIT, OnExit)
	ON_BN_CLICKED(IDC_SEND, OnSend)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CU2sDlg message handlers

BOOL CU2sDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_bind_close.EnableWindow(FALSE);	
	m_send.EnableWindow(FALSE);
	m_socket.m_app = (void *)this;
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CU2sDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CU2sDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CU2sDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

CString CU2sDlg::addr2str(CIPAddressCtrl& ip_addr)
{
	BYTE a0, a1, a2, a3;
	CString addrstr;
	
	ip_addr.GetAddress(a0, a1, a2, a3);
	addrstr.Format("%u.%u.%u.%u", a0, a1, a2, a3);
	return addrstr;
}

void CU2sDlg::OnBind() 
{
	CString msg;
	int nError = -1;
	int opt;

	struct ip_mreq mreq;
	BYTE a0, a1, a2, a3;

	UpdateData(TRUE);

	if ( m_socket.Create(m_local_udp_port, SOCK_DGRAM) ) 
	{
		m_remote_ip.GetAddress(a0, a1, a2, a3);
		if((a0 & 0xf0) == 0xe0)
		{
			m_remote_ip.GetAddress(mreq.imr_multiaddr.s_addr);
			mreq.imr_multiaddr.s_addr = htonl(mreq.imr_multiaddr.s_addr);
			mreq.imr_interface.s_addr = INADDR_ANY;
			if(!m_socket.SetSockOpt(IP_ADD_MEMBERSHIP, &mreq, sizeof(mreq), IPPROTO_IP))
			{
				nError = m_socket.GetLastError();
				m_socket.Close();
			}
		}
		else
		{
			opt = 1;
			if(!m_socket.SetSockOpt(SO_BROADCAST, &opt, sizeof(opt), SOL_SOCKET))
			{
				nError = m_socket.GetLastError();
				m_socket.Close();
			}
		}

	} 
	else 
	{
		nError = m_socket.GetLastError();
	}

	if ( nError != -1 ) {
		switch(nError)
		{
			case WSAENETDOWN:
				AfxMessageBox("Network subsystem fail");
				break;
			case WSAEADDRINUSE:
				AfxMessageBox("Address already in use");
				break;
			case WSAEADDRNOTAVAIL:
				AfxMessageBox("Address not available");
				break;
			case WSAECONNREFUSED:
				AfxMessageBox("Connection refused by peer");
				break;
			case WSAEINVAL:
				AfxMessageBox("Invalid host name");
				break;
			case WSAENETUNREACH:
				AfxMessageBox("Host unreachable");
				break;
			case WSAECONNRESET:
				AfxMessageBox("Connection reset by peer");
				break;
			default:
				AfxMessageBox("Unknown network error");
				break;
		}
	}
	else
	{
		m_bind.EnableWindow(FALSE);
		m_bind_close.EnableWindow(TRUE);
		m_send.EnableWindow(TRUE);
		msg.Format("Open UDP port (%u)....", m_local_udp_port);
		m_console.ReplaceSel(msg);
	}
}

void CU2sDlg::OnBindClose() 
{
	m_socket.Close();
	m_console.ReplaceSel("Close UDP port.\r\n");
	m_bind.EnableWindow(TRUE);
	m_bind_close.EnableWindow(FALSE);
	m_send.EnableWindow(FALSE);
}

void CU2sDlg::OnExit() 
{
	PostQuitMessage(0);	
}

// Callback functions
void CU2sDlg::DlgOnReceive(int nErrorCode)
{
	int len, count;
	CString msg;
	BYTE buf[1024];

	len = m_socket.Receive(buf, 1024, 0);
	for(count = 0; count < len; count++)
	{
		msg.Format(_T("%c"), buf[count]);
		m_console.ReplaceSel(msg);
	}
}

void CU2sDlg::DlgOnClose(int nErrorCode)
{
	m_socket.Close();
	m_console.ReplaceSel("Connection closed.\r\n");
	m_bind.EnableWindow(TRUE);
	m_bind_close.EnableWindow(FALSE);
	m_send.EnableWindow(FALSE);
}

void CU2sDlg::OnSend() 
{
	char buf[128];
	int len;

	int ilen = m_send_box.LineLength(m_send_box.LineIndex(0));

	len = m_send_box.GetLine(0, buf, ilen);

	if(m_check_cr.GetCheck())
	{
		buf[len] = 0x0d;
		len++;
	}
	if(m_check_lf.GetCheck())
	{
		buf[len] = 0x0a;
		len++;
	}

	m_send_box.SetSel(0, -1);
	m_send_box.Clear();

	SOCKADDR_IN saddr;
	BYTE a0, a1, a2, a3;
	CString addr;

	m_remote_ip.GetAddress(a0, a1, a2, a3);
	addr.Format("%u.%u.%u.%u", a0, a1, a2, a3);

	saddr.sin_family = AF_INET;
	saddr.sin_addr.s_addr = inet_addr(addr);
	saddr.sin_port = htons(m_remote_udp_port);
	
	m_socket.SendTo(buf, len, (SOCKADDR *)&saddr, sizeof(saddr), 0);
}
